KParts::Part Class Reference

`#include <part.h>`

Inheritance diagram for KParts::Part:

## Signals

void | setWindowCaption (const QString &caption)
void | setStatusBarText (const QString &text)

## Public Member Functions

| Part (QObject *parent=0, const char *name=0)
virtual | ~Part ()
virtual void | embed (QWidget *parentWidget)
virtual QWidget * | widget ()
virtual void | setManager (PartManager *manager)
PartManager * | manager () const
virtual Part * | hitTest (QWidget *widget, const QPoint &globalPos)
virtual void | setSelectable (bool selectable)
bool | isSelectable () const
Public Member Functions inherited from KParts::PartBase
| PartBase ()
virtual | ~PartBase ()
void | setPartObject (QObject *object)
QObject * | partObject () const

## Protected Member Functions

virtual void | setWidget (QWidget *widget)
virtual void | customEvent (QCustomEvent *event)
virtual void | partActivateEvent (PartActivateEvent *event)
virtual void | partSelectEvent (PartSelectEvent *event)
virtual void | guiActivateEvent (GUIActivateEvent *event)
QWidget * | hostContainer (const QString &containerName)
Protected Member Functions inherited from KParts::PartBase
virtual void | setInstance (KInstance *instance)
virtual void | setInstance (KInstance *instance, bool loadPlugins)
void | loadPlugins (QObject *parent, KXMLGUIClient *parentGUIClient, KInstance *instance)
void | setPluginLoadingMode (PluginLoadingMode loadingMode)

## Additional Inherited Members

Protected Types inherited from KParts::PartBase
enum | PluginLoadingMode { DoNotLoadPlugins = 0, LoadPlugins = 1, LoadPluginsIfEnabled = 2 }

## Detailed Description

Base class for parts.

A "part" is a GUI component, featuring:

- A widget embeddedable in any application.
- GUI elements that will be merged in the "host" user interface (menubars, toolbars... ).

About the widget:
Note that KParts::Part does not inherit QWidget. This is due to the fact that the "visual representation" will probably not be a mere QWidget, but an elaborate one. That's why when implementing your KParts::Part (or derived) you should call KParts::Part::setWidget() in your constructor.

About the GUI elements:
Those elements trigger actions, defined by the part (action()). The layout of the actions in the GUI is defined by an XML file (setXMLFile()).

See also ReadOnlyPart and ReadWritePart, which define the framework for a "viewer" part and for an "editor"-like part. Use Part directly only if your part doesn't fit into those.

Definition at line 181 of file part.h.

## Constructor & Destructor Documentation

Part::Part | ( | QObject * | parent = `0`,
|  | const char * | name = `0`
| ) |  |

Constructor.

Parameters

  parent | Parent object of the part.
  name | QT-internal name of the part.

Definition at line 133 of file part.cpp.

Part::~Part | ( |  | ) |

virtual

Destructor.

Definition at line 142 of file part.cpp.

## Member Function Documentation

void Part::embed | ( | QWidget * | parentWidget | ) |

virtual

Embed this part into a host widget.

You don't need to do this if you created the widget with the correct parent widget - this is just a QWidget::reparent(). Note that the Part is still the holder of the QWidget, meaning that if you delete the Part, then the widget gets destroyed as well, and vice-versa. This method is not recommended since creating the widget with the correct parent is simpler anyway.

Definition at line 165 of file part.cpp.

void Part::guiActivateEvent | ( | GUIActivateEvent * | event | ) |

protected virtual

Convenience method which is called when the Part received a GUIActivateEvent .

Reimplement this if you don't want to reimplement event and test for the event yourself or even install an event filter.

Reimplemented in KParts::ReadOnlyPart.

Definition at line 252 of file part.cpp.

Part * Part::hitTest | ( | QWidget * | widget,
|  | const QPoint & | globalPos
| ) |  |

virtual

Returns the part (this, or a child part) at the given global position.

This is called by the part manager to ask whether a part should be activated when clicking somewhere. In most cases the default implementation is enough. Reimplement this if your part has child parts in some areas (like in khtml or koffice)

Parameters

  widget | the part widget being clicked - usually the same as widget(), except in koffice.
  globalPos | the mouse coordinates in global coordinates

Definition at line 186 of file part.cpp.

QWidget * Part::hostContainer | ( | const QString & | containerName | ) |

protected

Convenience method for KXMLGUIFactory::container.

Returns
  a container widget owned by the Part's GUI.

Definition at line 256 of file part.cpp.

bool Part::isSelectable | ( |  | ) | const

Returns whether the part is selectable or not.

Definition at line 216 of file part.cpp.

PartManager * Part::manager | ( |  | ) | const

Returns the part manager handling this part, if any (0L otherwise).

Definition at line 181 of file part.cpp.

void Part::partActivateEvent | ( | PartActivateEvent * | event | ) |

protected virtual

Convenience method which is called when the Part received a PartActivateEvent .

Reimplement this if you don't want to reimplement event and test for the event yourself or even install an event filter.

Definition at line 244 of file part.cpp.

void Part::partSelectEvent | ( | PartSelectEvent * | event | ) |

protected virtual

Convenience method which is called when the Part received a PartSelectEvent .

Reimplement this if you don't want to reimplement event and test for the event yourself or even install an event filter.

Definition at line 248 of file part.cpp.

void Part::setSelectable | ( | bool | selectable | ) |

virtual

Parameters

  selectable | Indicates whether the part is selectable or not.

Definition at line 211 of file part.cpp.

void KParts::Part::setStatusBarText | ( | const QString & | text | ) |

signal

Emited by the part, to set a text in the statusbar of the window(s) hosting this part.

void Part::setWidget | ( | QWidget * | widget | ) |

protected virtual

Set the main widget.

Call this in the Part-inherited class constructor.

Definition at line 194 of file part.cpp.

void KParts::Part::setWindowCaption | ( | const QString & | caption | ) |

signal

Emitted by the part, to set the caption of the window(s) hosting this part.

QWidget * Part::widget | ( |  | ) |

virtual

Returns
  The widget defined by this part, set by setWidget().

Definition at line 171 of file part.cpp.

The documentation for this class was generated from the following files:

- part.h
- part.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys